/***** BEGIN License Block *****
 * Version 1.1 MPL
 *
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License").  You may not use this 
 * file except in compliance with the License. You may obtain a 
 * copy of the License at http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed on an 
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express  
 * or implied. See the License for the specific language governing 
 * rights and limitations under the License.
 *
 * The Original Code is Civil Netizen
 *
 * The Initial Developer of the Original Code is Civil Engines 
 * Research. Portions created by Civil Engines Research LLC are 
 * Copyright (C) 2001-2005 Civil Engines Research.  All Rights 
 * Reserved.  
 *
 * Portions created by Netscape Copyright (C) 1998 Netscape 
 * Communications Corporation. All Rights Reserved.
 *
 * Portions created by the Mozilla Foundation are Copyright (C) 
 * 2003 Mozilla Foundation. All Rights Reserved.
 *
 * Redistribution of the Original Code or portions of the Original
 * Code or Software under this agreement must retain the above 
 * copyright notice, this redistribution statement and the following 
 * disclaimer.  Neither the name of Civil Engines Research nor the 
 * names of its contributors may be used to endorse or promote any
 * products derived from this software without specific prior 
 * written permission from Civil Engines Research.
 *
 *
 * Contributor(s): 
 *   Paolo de Dios <paolo.dedios@civilengines.com> (original author)
 *
 *
 ***** END License Block *****/


var ScriptLoader =
{
    globalScriptsLoaded : false,
    
    loadGlobalToolkitScripts : function()
    {
        if(this.globalScriptsLoaded == false)
        {
            var scriptLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
                .getService(Components.interfaces.mozIJSSubScriptLoader);
            
            if(scriptLoader)
            {
                scriptLoader.loadSubScript("chrome://global/content/utils/nsLocalPreferences.js");
                scriptLoader.loadSubScript("chrome://global/content/utils/ceTraceLogService.js");
                scriptLoader.loadSubScript("chrome://global/content/utils/ceComponentConnector.js");
            }
        }
        
        this.globalScriptsLoaded = true;
        
        return;
    }
};


/////////////////////////////////////////////////////////////////////////////////
//
// ceIWindowCloser Implementation
//
/////////////////////////////////////////////////////////////////////////////////


function ceNetizenWindowCloser()
{
    ScriptLoader.loadGlobalToolkitScripts();
}


ceNetizenWindowCloser.prototype =
{
    QueryInterface : function(iid) 
    {
        if (!iid.equals(Interfaces.nsISupports)     &&
            !iid.equals(Interfaces.ceIWindowCloser)  )
        {
            throw Components.errors.NS_ERROR_NO_INTERFACE;
        }
        
        return this;
    },

    closeAllWindows : function(confirmClose)
    {
        var windowMediator   = do_GetService("@mozilla.org/appshell/window-mediator;1",
                                             Interfaces.nsIWindowMediator             );
        
        var windowEnumerator = windowMediator.getEnumerator(null);
 
        while(windowEnumerator.hasMoreElements()) 
        {
            var domWindow = windowEnumerator.getNext();

            if(confirmClose && ("tryToClose" in domWindow)) 
            {
                if(!domWindow.tryToClose())
                {
                    return false;
                }                
            }

            domWindow.close();
        }
        
        return true;
    }    
};



/////////////////////////////////////////////////////////////////////////////////
//
// nsIFactory Implementation
//
/////////////////////////////////////////////////////////////////////////////////


var ceNetizenWindowCloserModule = 
{
    moduleObjects :
    {
        ceNetizenWindowCloser :
        {
            CID        : Components.ID("{28e3285d-25b0-421f-af51-ac4e69a507b5}"),
            contractID : "@civilengines.com/runtime/app-shutdown;1",
            className  : "ceNetizenWindowCloser",
            factory    : 
            {
                createInstance : function(outer, iid) 
                {
                    if(outer != null)
                    {
                        throw Components.results.NS_ERROR_NO_AGGREGATION;
                    }
                    
                    var netizenWindowCloser = new ceNetizenWindowCloser();
                    return netizenWindowCloser.QueryInterface(iid);
                }       
            }
        },
    },
    
    registerSelf : function(componentManager, fileSpec, location, type) 
    {
        componentManager = componentManager.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    
        for(var key in this.moduleObjects) 
        {
            var moduleObject = this.moduleObjects[key];

            componentManager.registerFactoryLocation(moduleObject.CID       , 
                                                     moduleObject.className , 
                                                     moduleObject.contractID,
                                                     fileSpec               , 
                                                     location               ,
                                                     type                   );
        }

        return;
    },

    unregisterSelf : function(componentManager, fileSpec, location, type) 
    {
        componentManager = componentManager.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    
        for(var key in this.moduleObjects) 
        {
            var moduleObject = this.moduleObjects[key];

            componentManager.unregisterFactoryLocation(moduleObject.CID       , 
                                                       moduleObject.className , 
                                                       moduleObject.contractID,
                                                       fileSpec               , 
                                                       location               ,
                                                       type                   );
        }

        return;        
    },
    
    getClassObject : function(componentManager, cid, iid)
    {
        if(!iid.equals(Components.interfaces.nsIFactory))
        {
            throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
        }
        
        for(var key in this.moduleObjects)
        {
            if(cid.equals(this.moduleObjects[key].CID))
            {
                return this.moduleObjects[key].factory;
            }
        }
            
        throw Components.results.NS_ERROR_NO_INTERFACE;
    },
  

    canUnload : function(componentManager)
    {
        return true;
    }
};



function NSGetModule(componentManager, fileSpec)
{
    return ceNetizenWindowCloserModule;
}
