/***** BEGIN License Block *****
 * Version 1.1 MPL
 *
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License").  You may not use this 
 * file except in compliance with the License. You may obtain a 
 * copy of the License at http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed on an 
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express  
 * or implied. See the License for the specific language governing 
 * rights and limitations under the License.
 *
 * The Original Code is the mozilla.org code
 *
 * Contributor(s):
 *  Alec Flett  <alecf@netscape.com>
 *  Ben Goodger <ben@netscape.com>
 *  Blake Ross  <blakeross@telocity.com>
 *  Joe Hewitt <hewitt@netscape.com>
 *
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation. Portions created by the Initial Developer are Copyright
 * (C) 1998 the Initial Developer. All Rights Reserved.
 *
 * Portions created by Civil Engines Research LLC are Copyright (C)
 * 2001-2003 Civil Engines Research.  All Rights 
 * Reserved.
 *
 * Redistribution of the Original Code or portions of the Original
 * Code or Software under this agreement must retain the above 
 * copyright notice, this redistribution statement and the following 
 * disclaimer.  Neither the name of Civil Engines Research nor the 
 * names of its contributors may be used to endorse or promote any
 * products derived from this software without specific prior 
 * written permission from Civil Engines Research.
 *
 *
 ***** END License Block *****/

var gCommonDialogParam = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);
  
function showControls()
{
    /* This is called before onload fires, so we can't be certain that any elements
     * in the document have their bindings ready, so don't call any methods/properties
     * here on xul elements that come from xbl bindings.
     */

    /* show the required textboxes and set their initial values */
    var nTextBoxes = gCommonDialogParam.GetInt(3);
    if(nTextBoxes == 2) 
    {
        if(gCommonDialogParam.GetInt(4) == 1)
        {
            initTextbox("password1", 4, 6, false);
            initTextbox("password2", 5, 7, false);
        }
        else 
        {
            initTextbox("login", 4, 6, false);
            initTextbox("password1", 5, 7, false);
        }
    } 
    else if (nTextBoxes == 1) 
    {
        if(gCommonDialogParam.GetInt(4) == 1)
        {
            initTextbox("password1", -1, 6, true);
        }
        else
        {
            initTextbox("login", 4, 6, true);
        }
    }
    
    return;
}



function setLabelForNode(aNode, aLabel, aIsLabelFlag)
{
    /* This is for labels with possible accesskeys */
    var accessKeyIndex;
    
    if(/^\&[^\&]/.test(aLabel))
    {
        accessKeyIndex = 0;
    } 
    else 
    {
        accessKeyIndex = aLabel.search(/[^\&]\&[^\&]/) + 1;
        if(accessKeyIndex == 0) 
        {
            accessKeyIndex = -1;
        }
    }

    /* If a character has an & before it, then it should become an accesskey */
    if(accessKeyIndex >= 0 && accessKeyIndex < aLabel.length - 1) 
    {
        /* This will also cause the accesskey attribute to be set via xbl */
        aNode.accessKey = aLabel.charAt(accessKeyIndex + 1);

        /* Set the label to the string without the & */
        aLabel = aLabel.substr(0, accessKeyIndex) + aLabel.substr(accessKeyIndex + 1);
    }

    aLabel = aLabel.replace(/\&\&/g, "&");
    
    if(aIsLabelFlag)
    {
        aNode.setAttribute("value", aLabel);
    } 
    else 
    {
        aNode.label = aLabel;
    }

    return;
}



function commonDialogOnLoad()
{

//@line 132 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/commonDialog.js"
    document.title = gCommonDialogParam.GetString(12);
//@line 134 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/commonDialog.js"

    /* set the number of command buttons */
    var nButtons = gCommonDialogParam.GetInt(2);
    var dialog = document.documentElement;
    switch(nButtons) 
    {
      case 1:
      {
          dialog.getButton("cancel").hidden = true;
          break;
      }
      case 4:
      {          
          dialog.getButton("extra2").hidden = false;
      }
      case 3:
      {          
          dialog.getButton("extra1").hidden = false;
      }
    }
    
    /* display the main text */
    var messageText       = gCommonDialogParam.GetString(0);
    var messageParent     = document.getElementById("info.box");
    var messageParagraphs = messageText.split("\n");
    
    for(var i = 0; i < messageParagraphs.length; i++) 
    {
        var descriptionNode = document.createElement("description");
        var text            = document.createTextNode(messageParagraphs[i]);
        descriptionNode.appendChild(text);
        messageParent.appendChild(descriptionNode);
    }

    setElementText("info.header", gCommonDialogParam.GetString(3), true);

    /* set the icon */
    var iconElement = document.getElementById("info.icon");
    var iconClass   = gCommonDialogParam.GetString(2);
    if(!iconClass)
    {
        iconClass = "message-icon";
    }
    
    iconElement.setAttribute("class", iconElement.getAttribute("class") + " " + iconClass);

    switch(nButtons) 
    {
      case 4:
      {          
          setLabelForNode(document.documentElement.getButton("extra2"), gCommonDialogParam.GetString(11));
      }
      case 3:
      {          
          setLabelForNode(document.documentElement.getButton("extra1"), gCommonDialogParam.GetString(10));
      }
      default:
      case 2:
      {            
          var string = gCommonDialogParam.GetString(9);
          if(string)
          {
              setLabelForNode(document.documentElement.getButton("cancel"), string);
          }
      }        
      case 1:
      {            
          string = gCommonDialogParam.GetString(8);
          if(string)
          {
              setLabelForNode(document.documentElement.getButton("accept"), string);
          }
          
          break;
      }
    }

    /* set default result to cancelled */
    gCommonDialogParam.SetInt(0, 1); 

    /* initialize the checkbox */
    setCheckbox(gCommonDialogParam.GetString(1), gCommonDialogParam.GetInt(1));

    if(gCommonDialogParam.GetInt(3) == 0)
    {
        var dlgButtons = ['accept', 'cancel', 'extra1', 'extra2'];

        /* Set the default button and focus it */
        var dButton = dlgButtons[gCommonDialogParam.GetInt(5)];
        document.documentElement.defaultButton = dButton;
        document.documentElement.getButton(dButton).focus();
    }

    if(gCommonDialogParam.GetInt(6) != 0)
    {
        var delayInterval = 2000;
        try 
        {
            var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                .getService(Components.interfaces.nsIPrefBranch);

            delayInterval = prefs.getIntPref("security.dialog_enable_delay");
        } 
        catch (exception) 
        {
        }

        document.documentElement.getButton("accept").disabled = true;
        document.documentElement.getButton("extra1").disabled = true;
        document.documentElement.getButton("extra2").disabled = true;

        setTimeout(commonDialogReenableButtons, delayInterval);
    
        addEventListener("blur", commonDialogBlur, false);
        addEventListener("focus", commonDialogFocus, false);
    }

    getAttention();

    return;
}



var gDelayExpired = false;
var gBlurred      = false;

function commonDialogBlur(aEvent)
{
    if(aEvent.target != document)
    {
        return;
    }
    
    gBlurred = true;
    document.documentElement.getButton("accept").disabled = true;
    document.documentElement.getButton("extra1").disabled = true;
    document.documentElement.getButton("extra2").disabled = true;
    
    return;
}



function commonDialogFocus(aEvent)
{
    if(aEvent.target != document)
    {
        return;
    }
    
    gBlurred = false;
    
    /* When refocusing the window, don't enable the buttons 
     * unless the countdown delay has expired.
     */ 
    if(gDelayExpired)
    {
        var script = "document.documentElement.getButton('accept').disabled = false; ";
        script    += "document.documentElement.getButton('extra1').disabled = false; ";
        script    += "document.documentElement.getButton('extra2').disabled = false;";
        setTimeout(script, 250);
    }

    return;
}


function commonDialogReenableButtons()
{
    /* Don't automatically enable the buttons if we're not in the foreground */
    if(!gBlurred)
    {
        document.documentElement.getButton("accept").disabled = false;
        document.documentElement.getButton("extra1").disabled = false;
        document.documentElement.getButton("extra2").disabled = false;
    }

    gDelayExpired = true;

    return;
}


function initTextbox(aName, aLabelIndex, aValueIndex, aAlwaysLabel)
{
    unHideElementById(aName+"Container");

    var label = aLabelIndex < 0 ? "" : gCommonDialogParam.GetString(aLabelIndex);
    if(label || aAlwaysLabel && !label)
    {
        setElementText(aName + "Label", label);
    }
    
    var value   = aValueIndex < 0 ? "" : gCommonDialogParam.GetString(aValueIndex);
    var textbox = document.getElementById(aName + "Textbox");

    textbox.setAttribute("value", value);

    return;
}



function setElementText(aElementID, aValue, aChildNodeFlag)
{
    var element = document.getElementById(aElementID);
    if(!aChildNodeFlag && element) 
    {
        setLabelForNode(element, aValue, true);
    } 
    else if (aChildNodeFlag && element) 
    {
        element.appendChild(document.createTextNode(aValue));
    }

    return;
}


function setCheckbox(aChkMsg, aChkValue)
{
    if(aChkMsg)
    {
        document.getElementById("checkboxContainer").removeAttribute("collapsed");
        
        var checkboxElement = document.getElementById("checkbox");
        setLabelForNode(checkboxElement, aChkMsg);
        checkboxElement.checked = aChkValue > 0;
    }
  
    return;
}


function unHideElementById(aElementID)
{
    var element = document.getElementById(aElementID);
    element.hidden = false;

    return;
}



function hideElementById(aElementID)
{
    var element = document.getElementById(aElementID);
    element.hidden = true;

    return;
}


function isVisible(aElementId)
{
    return document.getElementById(aElementId).hasAttribute("hidden");
}


function onCheckboxClick(aCheckboxElement)
{
    gCommonDialogParam.SetInt(1, aCheckboxElement.checked);
    return;
}


function commonDialogOnAccept()
{
    gCommonDialogParam.SetInt(0, 0);

    var numTextBoxes = gCommonDialogParam.GetInt(3);
    var textboxIsPassword1 = gCommonDialogParam.GetInt(4) == 1;
  
    if(numTextBoxes >= 1) 
    {
        var editField1;
        if(textboxIsPassword1)
        {
            editField1 = document.getElementById("password1Textbox");
        }        
        else
        {
            editField1 = document.getElementById("loginTextbox");
        }
        
        gCommonDialogParam.SetString(6, editField1.value);
    }

    if(numTextBoxes == 2)
    {
        var editField2;
        if(textboxIsPassword1)
        {
            editField2 = document.getElementById("password2Textbox");
        }        
        else
        {
            editField2 = document.getElementById("password1Textbox");
        }
        
        gCommonDialogParam.SetString(7, editField2.value);
    }

    return;
}



function commonDialogOnExtra1()
{
    gCommonDialogParam.SetInt(0, 2);
    window.close();

    return;
}



function commonDialogOnExtra2()
{
    gCommonDialogParam.SetInt(0, 3);
    window.close();
    
    return;
}
