/***** BEGIN License Block *****
 * Version 1.1 MPL
 *
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License").  You may not use this 
 * file except in compliance with the License. You may obtain a 
 * copy of the License at http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed on an 
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express  
 * or implied. See the License for the specific language governing 
 * rights and limitations under the License.
 *
 * The Original Code is the mozilla.org code
 *
 * Contributor(s):
 *  Joe Hewitt <hewitt@netscape.com>
 *
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation. Portions created by the Initial Developer are Copyright
 * (C) 1998 the Initial Developer. All Rights Reserved.
 *
 * Portions created by Civil Engines Research LLC are Copyright (C)
 * 2001-2003 Civil Engines Research.  All Rights 
 * Reserved.
 *
 * Redistribution of the Original Code or portions of the Original
 * Code or Software under this agreement must retain the above 
 * copyright notice, this redistribution statement and the following 
 * disclaimer.  Neither the name of Civil Engines Research nor the 
 * names of its contributors may be used to endorse or promote any
 * products derived from this software without specific prior 
 * written permission from Civil Engines Research.
 *
 *
 ***** END License Block *****/

var FullScreen = 
{
    toggle: function()
    {
        /* show/hide all menubars, toolbars, and statusbars (except the full screen toolbar) */
        this.showXULChrome("menubar", window.fullScreen);
        this.showXULChrome("toolbar", window.fullScreen);
        this.showXULChrome("statusbar", window.fullScreen);
        
        return;
    },
  

    showXULChrome: function(aTag, aShow)
    {
        var XULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
        var els = document.getElementsByTagNameNS(XULNS, aTag);
    
        var i;
        for(i = 0; i < els.length; ++i) 
        {
            if(els[i].getAttribute("fullscreentoolbar") == "true") 
            {
                this.setToolbarButtonMode(els[i], aShow ? "" : "small");
            } 
            else 
            {
                /* use moz-collapsed so it doesn't persist hidden/collapsed,
                 * so that new windows don't have missing toolbars
                 */
                if(aShow)
                {
                    els[i].removeAttribute("moz-collapsed");
                }    
                else
                {
                    els[i].setAttribute("moz-collapsed", "true");
                }
            }
        }
//@line 79 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/fullScreen.js"
        var controls = document.getElementsByAttribute("fullscreencontrol", "true");
        for (i = 0; i < controls.length; ++i)
        {
            controls[i].hidden = aShow;
        }
//@line 85 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/fullScreen.js"

        return;
    },

    
    setToolbarButtonMode: function(aToolbar, aMode)
    {
        aToolbar.setAttribute("toolbarmode", aMode);
        this.setToolbarButtonModeFor(aToolbar, "toolbarbutton", aMode);
        this.setToolbarButtonModeFor(aToolbar, "button", aMode);
        this.setToolbarButtonModeFor(aToolbar, "textbox", aMode);
        
        return;
    },
  

    setToolbarButtonModeFor: function(aToolbar, aTag, aMode)
    {
        var XULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
        var els = aToolbar.getElementsByTagNameNS(XULNS, aTag);

        for(var i = 0; i < els.length; ++i)
        {
            els[i].setAttribute("toolbarmode", aMode);
        }
        
        return;
    }  
};
