/***** BEGIN License Block *****
 * Version 1.1 MPL
 *
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License").  You may not use this 
 * file except in compliance with the License. You may obtain a 
 * copy of the License at http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed on an 
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express  
 * or implied. See the License for the specific language governing 
 * rights and limitations under the License.
 *
 * The Original Code is the mozilla.org code
 *
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation. Portions created by the Initial Developer are Copyright
 * (C) 1998 the Initial Developer. All Rights Reserved.
 *
 * Portions created by Civil Engines Research LLC are Copyright (C)
 * 2001-2003 Civil Engines Research.  All Rights 
 * Reserved.
 *
 * Redistribution of the Original Code or portions of the Original
 * Code or Software under this agreement must retain the above 
 * copyright notice, this redistribution statement and the following 
 * disclaimer.  Neither the name of Civil Engines Research nor the 
 * names of its contributors may be used to endorse or promote any
 * products derived from this software without specific prior 
 * written permission from Civil Engines Research.
 *
 ***** END License Block *****/


function closeWindow(shouldClose)
{
    var windowCount      = 0;
    var windowManager    = Components.classes['@mozilla.org/appshell/window-mediator;1'];
    var windowMediator   = windowManager.getService(Components.interfaces.nsIWindowMediator);
    var windowEnumerator = windowMediator.getEnumerator(null);
    
    while(windowEnumerator.hasMoreElements()) 
    {
        var windowElement = windowEnumerator.getNext();
        if(++windowCount == 2)
        { 
            break;
        }
    }
    
//@line 52 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/globalOverlay.js"
    /* If we're down to the last window and someone tries to shut down, 
     * check to make sure we can
     */
    if(windowCount == 1 && !canQuitApplication())
    { 
        return false;
    }
//@line 60 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/globalOverlay.js"

    if(shouldClose)
    {    
        window.close();
    }
    
    return true;
}




function canQuitApplication()
{
    var observerClass   = Components.classes["@mozilla.org/observer-service;1"];
    var observerService = observerClass.getService(Components.interfaces.nsIObserverService);
    if(observerService) 
    {
        try 
        {
            var cancelQuit = Components.classes["@mozilla.org/supports-PRBool;1"].
                createInstance(Components.interfaces.nsISupportsPRBool);
            
            observerService.notifyObservers(cancelQuit, "quit-application-requested", null);
            if(cancelQuit.data)
            {
                return false;
            }
        }
        catch(exception) 
        {
        }
    }


    observerService.notifyObservers(null, "quit-application-granted", null);
    return true;
}




function goQuitApplication()
{
    if(!canQuitApplication())
    {
        return false;
    }
    
    var windowManager    = Components.classes['@mozilla.org/appshell/window-mediator;1'];
    var windowMediator   = windowManager.getService(Components.interfaces.nsIWindowMediator);
    var windowEnumerator = windowMediator.getEnumerator(null);

    var appStartupClass  = Components.classes['@civilengines.com/runtime/app-startup;1'];
    var appStartup       = appStartupClass.getService(Components.interfaces.ceIAppStartup);
   
    while(windowEnumerator.hasMoreElements())
    {
        var domWindow = windowEnumerator.getNext();
        if(("tryToClose" in domWindow) && !domWindow.tryToClose())
        {
            return false;          
        }

        domWindow.close();
    }

    appStartup.quit(Components.interfaces.ceIAppStartup.ATTEMPT_QUIT);

    return true;
}



function goUpdateCommand(command)
{
    try 
    {
        var controller = top.document.commandDispatcher.getControllerForCommand(command);
        var enabled    = false;
        
        if(controller)
        {
            enabled = controller.isCommandEnabled(command);
        }
        
        goSetCommandEnabled(command, enabled);
    }
    catch(exception) 
    {
        dump("An error occurred updating the " + command + " command\n");
    }

    return;
}




function goDoCommand(command)
{    
    try 
    {
        var controller = top.document.commandDispatcher.getControllerForCommand(command);
        if(controller && controller.isCommandEnabled(command))
        {
            controller.doCommand(command);
        }
    }
    catch(exception) 
    {
        dump("An error occurred executing the " + command + " command\n");
        dump(exception + "\n");    
    }

    return;
}




function goCheckCommandIsEnabled(command)
{
    var controller = top.document.commandDispatcher.getControllerForCommand(command);
    return (controller && controller.isCommandEnabled(command))
}



function goSetCommandEnabled(id, enabled)
{
    var node = document.getElementById(id);

    if(node)
    {
        if(enabled)
        {
            node.removeAttribute("disabled");
        }
        else
        {
            node.setAttribute('disabled', 'true');
        }
    }

    return;
}



function goSetMenuValue(command, labelAttribute)
{
    var commandNode = top.document.getElementById(command);
    if( commandNode )
    {
        var label = commandNode.getAttribute(labelAttribute);
        if(label)
        {
            commandNode.setAttribute('label', label);
        }
    }

    return;
}




function goSetAccessKey(command, valueAttribute)
{
    var commandNode = top.document.getElementById(command);
    if(commandNode)
    {
        var value = commandNode.getAttribute(valueAttribute);
        if(value)
        {
            commandNode.setAttribute('accesskey', value);
        }
    }

    return;
}



/* This function is used to inform all the controllers attached to a 
 * node that an event has occurred (e.g. the tree controllers need to
 * be informed of blur events so that they can change some of the
 * menu items back to their default values)
 */
function goOnEvent(node, event)
{
    var numControllers = node.controllers.getControllerCount();
    var controller;
    
    for(var controllerIndex = 0; controllerIndex < numControllers; controllerIndex++)
    {
        controller = node.controllers.getControllerAt(controllerIndex);
        if(controller)
        {
            controller.onEvent(event);
        }
    }

    return;
}



function isValidLeftClick(event, name)
{
    return (event.button == 0 && event.originalTarget.localName == name);
}



function setTooltipText(elementID, tooltipText)
{
    var element = document.getElementById(elementID);
    if(element)
    {
        element.setAttribute("tooltiptext", tooltipText);
    }

    return;
}
