/***** BEGIN License Block *****
 * Version 1.1 MPL
 *
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License").  You may not use this 
 * file except in compliance with the License. You may obtain a 
 * copy of the License at http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed on an 
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express  
 * or implied. See the License for the specific language governing 
 * rights and limitations under the License.
 *
 * The Original Code is the mozilla.org code
 *
 * Contributor(s):
 *  Alec Flett  <alecf@netscape.com>
 *
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation. Portions created by the Initial Developer are Copyright
 * (C) 1998 the Initial Developer. All Rights Reserved.
 *
 * Portions created by Civil Engines Research LLC are Copyright (C)
 * 2001-2003 Civil Engines Research.  All Rights 
 * Reserved.
 *
 * Redistribution of the Original Code or portions of the Original
 * Code or Software under this agreement must retain the above 
 * copyright notice, this redistribution statement and the following 
 * disclaimer.  Neither the name of Civil Engines Research nor the 
 * names of its contributors may be used to endorse or promote any
 * products derived from this software without specific prior 
 * written permission from Civil Engines Research.
 *
 *
 ***** END License Block *****/

var elements = [];
var numItems;
var list;
var param;

function selectDialogOnLoad() 
{
    param = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);

    var messageText = param.GetString(1);
    {
        var messageFragment;
        var messageParent = (document.getElementById("textinfo"));
        var done = false;

        while(!done) 
        {
            var breakIndex = messageText.indexOf('\n');
            if(breakIndex == 0) 
            {
                /* Ignore break at the first character */
                messageText = messageText.slice(1);
                messageFragment = "";
            } 
            else if (breakIndex > 0) 
            {
                /* The fragment up to the break */
                messageFragment = messageText.slice(0, breakIndex);

                /* Chop off fragment we just found from remaining string */
                messageText = messageText.slice(breakIndex+1);
            } 
            else 
            {
                /* "\n" not found. Complete */
                done = true;
                messageFragment = messageText;
            }

            messageParent.setAttribute("value", messageFragment);
        }
    }

    document.title = param.GetString(0);

    list = document.getElementById("list");
    numItems = param.GetInt(2);

    for(var i = 2; i <= numItems+1; i++) 
    {
        var newString = param.GetString(i);
        if(newString == "") 
        {
            newString = "<>";
        }

        elements[i-2] = AppendStringToListbox(list, newString);
    }

    list.selectItem(elements[0]);
    list.focus();
    
    /* resize the window to the content */
    window.sizeToContent();
    
    /* Move to the right location */
    moveToAlertPosition();

    param.SetInt(0, 1);

    centerWindowOnScreen();

    return;
}



function commonDialogOnOK() 
{
    for(var i = 0; i < numItems; i++) 
    {
        if(elements[i] == list.selectedItems[0]) 
        {
            param.SetInt(2, i);
            break;
        }
    }

    param.SetInt(0, 0);
    return true;
}


function commonDialogOnCancel()
{
    for(var i = 0; i < numItems; i++)
    {
        if(elements[i])
        {
            param.SetInt(2, i);
            break;
        }
    }

    param.SetInt(0, 1);
    return true;
}



function commonDialogOnDoubleClick()
{
    commonDialogOnOK();
    window.close();
}


function AppendStringToListbox(tree, string)
{
    if(tree)
    {
        var XULNS    = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
        var listbox  = document.getElementById('list');
        var listitem = document.createElementNS(XULNS, "listitem");
        
        if(listitem)
        {
            listitem.setAttribute("label", string);
            listitem.setAttribute("ondblclick","commonDialogOnDoubleClick()");
            listbox.appendChild(listitem);
            
            var len = Number(tree.getAttribute("length"));
            if(!len)
            {
                len = -1;
            }
            
            tree.setAttribute("length", len + 1);
            return listitem;
        }
    }

    return null;
}
