/***** BEGIN License Block *****
 * Version 1.1 MPL
 *
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License").  You may not use this 
 * file except in compliance with the License. You may obtain a 
 * copy of the License at http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed on an 
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express  
 * or implied. See the License for the specific language governing 
 * rights and limitations under the License.
 *
 * The Original Code is the Civil Netizen/Civil Servant.
 *
 * The Initial Developer of the Original Code is Civil Engines 
 * Research. Portions created by Civil Engines Research LLC are 
 * Copyright (C) 2001-2003 Civil Engines Research.  All Rights 
 * Reserved.
 *
 * Redistribution of the Original Code or portions of the Original
 * Code or Software under this agreement must retain the above 
 * copyright notice, this redistribution statement and the following 
 * disclaimer.  Neither the name of Civil Engines Research nor the 
 * names of its contributors may be used to endorse or promote any
 * products derived from this software without specific prior 
 * written permission from Civil Engines Research.
 *
 *
 * Contributor(s): 
 *   Paolo de Dios <paolo.dedios@civilengines.com> (original author)
 *
 *
 ***** END License Block *****/



function ceRDFNodeEnumerator(rdfEnumeration, datasource)
{
    this.enumerator = null;
    this.dataSource = null;
    
    if(rdfEnumeration)
    {
        this.enumerator = rdfEnumeration;
    }

    if(datasource)
    {
        this.dataSource = datasource;
    }
}


ceRDFNodeEnumerator.prototyope = 
{
    hasMoreElements : function()
    {
        return this.enumerator.hasMoreElements();
    },

    getNext : function()
    {
        var resourceElement = this.enumerator.getNext();
        var resourceValue   = nsnull;

        if(resourceElement != null)
        {

            resourceElement = do_QueryInterface(resourceElement                     ,
                                                Components.interfaces.nsIRDFResource);
            if(resourceElement)
            {
                resourceValue   = new ceRDFResource();                
            }
            else
            {    
                resourceElement = do_QueryInterface(resourceElement                 ,
                                                    Components.interfaces.nsILiteral);
                resourceValue   = (resourceElement) ? new ceRDFLiteral() : null;   
            }
            
            if(resourceValue && resourceElement)
            {
                resourceValue.node       = resourceElement;
                resourceValue.dataSource = this.dataSource;
            }
        }
        
        return resourceValue;
    }
};
