/***** BEGIN License Block *****
 * Version 1.1 MPL
 *
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License").  You may not use this 
 * file except in compliance with the License. You may obtain a 
 * copy of the License at http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed on an 
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express  
 * or implied. See the License for the specific language governing 
 * rights and limitations under the License.
 *
 * The Original Code is Civil Netizen/Civil Servant.
 *
 * The Initial Developer of the Original Code is Civil Engines 
 * Research. Portions created by Civil Engines Research LLC are 
 * Copyright (C) 2001-2005 Civil Engines Research.  All Rights 
 * Reserved.  
 *
 * Portions created by Netscape Copyright (C) 1998 Netscape 
 * Communications Corporation. All Rights Reserved.
 *
 * Portions created by the Mozilla Foundation are Copyright (C) 
 * 2003 Mozilla Foundation. All Rights Reserved.
 *
 * Redistribution of the Original Code or portions of the Original
 * Code or Software under this agreement must retain the above 
 * copyright notice, this redistribution statement and the following 
 * disclaimer.  Neither the name of Civil Engines Research nor the 
 * names of its contributors may be used to endorse or promote any
 * products derived from this software without specific prior 
 * written permission from Civil Engines Research.
 *
 *   Paolo de Dios <paolo.dedios@civilengines.com> (original author)
 *
 *
 ***** END License Block *****/


const TIMER_EVENT_TYPE_ONE_SHOT    = Components.interfaces.nsITimer.TYPE_ONE_SHOT;
const TIMER_EVENT_TYPE_REPEATING   = Components.interfaces.nsITimer.TYPE_REPEATING_SLACK;


function ceTimerEvent(eventCallback, parameterMap, timerDelay)
{
    if(eventCallback && timerDelay)
    {
        this.registerEvent(eventCallback, parameterMap, timerDelay);
    }
    
    return;
}


ceTimerEvent.prototype = 
{
    type       : TIMER_EVENT_TYPE_ONE_SHOT,
    callback   : null                     ,
    parameters : null                     ,
    timeout    : 0                        ,
    timerId    : 0                        ,


    eventTimerCallback(timerObject)
    {
        if(timerObject.callback && "onTimerEvent" in timerObject.callback)
        {
            timerObject.callback.onTimerEvent(timerObject.parameters);
        }
        
        return;
    },
    

    registerEvent : function(eventCallback, parameterMap, timerDelay, timerType)
    {
        this.callback   = eventCallback;
        this.parameters = parameters;
        this.timeout    = timerDelay;
        
        if(timerType)
        {
            this.type   = timerType;
        }
        
        if(this.timerType == TIMER_EVENT_TYPE_REPEATING)
        {
            this.timerId = window.setInterval(this.eventTimerCallback, this.timeout, this);
        }
        else
        {
            this.timerId = window.setTimeout(this.eventTimerCallback, this.timeout, this);
        }
        
        return this.timerId;
    },
    

    cancelEvent : function()
    {
        if(this.timerId)
        {
            if(this.timerType == TIMER_EVENT_TYPE_REPEATING)
            {
                window.clearInterval(this.timerId);
            }
            else
            {
                window.clearTimeout(this.timerId);
            }
            
            if(this.callback && "onTimerCancel" in this.callback)
            {
                this.callback.onCancelTimer(this.parameters);
            }
        }
        
        return;
    }
};

