/***** BEGIN License Block *****
 * Version 1.1 MPL
 *
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License").  You may not use this 
 * file except in compliance with the License. You may obtain a 
 * copy of the License at http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed on an 
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express  
 * or implied. See the License for the specific language governing 
 * rights and limitations under the License.
 *
 * The Original Code is the Civil Netizen/Civil Servant.
 *
 * The Initial Developer of the Original Code is Civil Engines 
 * Research. Portions created by Civil Engines Research LLC are 
 * Copyright (C) 2001-2003 Civil Engines Research.  All Rights 
 * Reserved.
 *
 * Redistribution of the Original Code or portions of the Original
 * Code or Software under this agreement must retain the above 
 * copyright notice, this redistribution statement and the following 
 * disclaimer.  Neither the name of Civil Engines Research nor the 
 * names of its contributors may be used to endorse or promote any
 * products derived from this software without specific prior 
 * written permission from Civil Engines Research.
 *
 *
 * Contributor(s): 
 *   Paolo de Dios <paolo.dedios@civilengines.com> (original author)
 *
 *
 ***** END License Block *****/

var NS_CONSOLESERVICE_CONTRACTID        = "@mozilla.org/consoleservice;1";
var CE_TRACELOGSERVICE_CONTRACTID       = "@civilengines.com/util/tracelog;1";
var CE_TRACELOGSERVICE_DEFAULT_MODULE   = "netizen";
var CE_TRACELOGSERVICE_DEFAULT_RECURSE  = 5;
var CE_TRACELOGSERVICE_DEFAULT_SPACE    = 0;


function ceTraceLogService()
{
    this.initSyslog();
}


ceTraceLogService.prototype =
{
    traceLogServiceImpl : null,
    consoleServiceImpl  : null,
    
    initSyslog : function()
    {
        var consoleServiceClass  = null;
        
        try
        {
            consoleServiceClass  = Components.classes[NS_CONSOLESERVICE_CONTRACTID];
            
            this.consoleServiceImpl =
                consoleServiceClass.getService(Components.interfaces.nsIConsoleService);
        }
        catch(exception)
        {
            this.consoleServiceImpl = null;
        }
        
//@line 85 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return;
    },
    


    logException : function(exception, messageString)
    {
//@line 114 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return;
    },
    


    logMessage : function(messageString)
    {
//@line 128 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return;
    },


    logMessageToModule : function(logModule, messageString)
    {
//@line 141 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return;
    },


    logMessageToConsole : function(logModule, messageString)
    {
        if(this.consoleServiceImpl && messageString)
        {
            var formalMessageString = "-*-*-*- [" + logModule.toUpperCase() + "]: " + messageString;
            this.consoleServiceImpl.logStringMessage(formalMessageString);
        }

        return;
    },
    
    getStackMessage : function(stackFrame)
    {
        if(!stackFrame)
        {
            return "";
        }
        
        var filename           = stackFrame.filename ? stackFrame.filename : "(unknown)";
        var functionName       = stackFrame.name     ? stackFrame.name     : "[anonymous]";
        
        var fileNameString     = "  FileName: "     + filename                + "\n";
        var functionNameString = "    function => " + functionName            + "\n";
        var lineNumber         = "    line     => " + stackFrame.lineNumber   + "\n";
        var languageName       = "    language => " + stackFrame.languageName + "\n";
        
        return (fileNameString + functionNameString + lineNumber + languageName);
    },

        
    getStackTrace : function()
    {
        var stackString = "STACK_TRACE: \n[TOP_OF_STACK]\n";
        var stackFrame  = Components.stack.caller;
        while(stackFrame)
        {
            stackString += this.getStackMessage(stackFrame);
            stackFrame   = stackFrame.caller;
        }

        stackString += "[END_OF_STACK]\n";        
        return stackString;
    },


    logStackTrace : function()
    {
//@line 218 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return;
    },

    /* Recursively dumps an object in tree format:
     * object    : Object to output
     * recurse   : Maximum recurse depth in terms of number of objects
     * compress  : Boolean flag whether or not to compress the output
     * level     : Number of spaces to initially indent
     */
    dumpObjectTree : function(obj, recurse, compress, level) 
    {
//@line 323 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"

        return;
    }
};



/* Place the trace log service in the global javascript 
 * namespace by creating a single instance as an immutable
 * object
 */
var Syslog   = new ceTraceLogService();


function ceDebugAssert()
{
    return;
}


ceDebugAssert.prototype =
{
    breakpoint : function(evalfunc, message, initialexpr)
    {
//@line 393 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return;
    },


    condition : function(testCondition, message)
    {
//@line 408 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return;
    },


    isObject : function(unknownObject, message)
    {
//@line 423 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return true;
    },


    isFunction : function(unknownObject, message)
    {
//@line 438 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return true;
    },

    isNull : function(unknownObject, message)
    {
//@line 452 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return true;
    },


    isNotNull : function(unknownObject, message)
    {
//@line 467 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return true;
    },
    
    isString : function(unknownObject, message)
    {
//@line 480 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return true;
    },

    isNumber : function(unknownObject, message)
    {
//@line 494 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return true;
    },

    isNaN : function(unknownObject, message)
    {
//@line 508 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return true;
    },

    isArray : function(unknownObject, message)
    {
//@line 521 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return true;
    },

    isUndefined : function(unknownObject, message)
    {
//@line 534 "/cygdrive/d/projects/cers/netizen.source/devel/mozilla/civil/runtime/toolkit/content/library/ceTraceLogService.js"
        return true;
    }
};



var Assert = new ceDebugAssert();

