/***** BEGIN License Block *****
 * Version 1.1 MPL
 *
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License").  You may not use this 
 * file except in compliance with the License. You may obtain a 
 * copy of the License at http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed on an 
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express  
 * or implied. See the License for the specific language governing 
 * rights and limitations under the License.
 *
 * The Original Code is the Civil Netizen/Civil Servant.
 *
 * The Initial Developer of the Original Code is Civil Engines 
 * Research. Portions created by Civil Engines Research LLC are 
 * Copyright (C) 2001-2003 Civil Engines Research.  All Rights 
 * Reserved.
 *
 * Redistribution of the Original Code or portions of the Original
 * Code or Software under this agreement must retain the above 
 * copyright notice, this redistribution statement and the following 
 * disclaimer.  Neither the name of Civil Engines Research nor the 
 * names of its contributors may be used to endorse or promote any
 * products derived from this software without specific prior 
 * written permission from Civil Engines Research.
 *
 *
 * Contributor(s): 
 *   Paolo de Dios <paolo.dedios@civilengines.com> (original author)
 *
 *
 ***** END License Block *****/

const APPLICATION_SERVICE_CONTRACTID        = "@civilengines.com/appshell/component/netizen;1";

var NetizenAboutDialog =
{
    loadDialog : function(eventInfo)
    {
        if(eventInfo.target != document)
        {
            return;
        }
        
        var applicationService = do_GetService(APPLICATION_SERVICE_CONTRACTID  ,
                                               Interfaces.ceIApplicationService);

        var releaseLevel = applicationService.releaseLevel;
        if(releaseLevel)
        {
            var dialogNetizenVersionLabel = document.getElementById("dialogNetizenVersionLabel");
            if(dialogNetizenVersionLabel)
            {
                dialogNetizenVersionLabel.setAttribute("value", releaseLevel);
            }
        }
        
        var platformInfo = applicationService.platformInfo;
        if(platformInfo)
        {
            var dialogNetizenPlatformLabel = document.getElementById("dialogNetizenPlatformLabel");
            if(dialogNetizenPlatformLabel)
            {
                dialogNetizenPlatformLabel.setAttribute("value", platformInfo);
            }
        }
        

        var okButton = document.documentElement.getButton("accept");
        if(okButton)
        {
            okButton.focus();
        }

        var creditsButton = document.documentElement.getButton("extra2");
        if(creditsButton)
        {
            creditsButton.addEventListener("command", this.showCredits, false);
        }
                        
        return;
    },
    

    unloadDialog : function(eventInfo)
    {
        var creditsButton = document.documentElement.getButton("extra2");
        if(creditsButton)
        {
            creditsButton.removeEventListener("command", this.showCredits, false);
        }

        return;
    },


    showCredits : function(eventInfo)
    {                
        var dialogAboutNetizenDeck = document.getElementById("dialogAboutNetizenDeck");
        if(!dialogAboutNetizenDeck)
        {
            return;
        }
        
        if(dialogAboutNetizenDeck.selectedIndex == 0)
        {
            var aboutButton = document.documentElement.getButton("extra2");
            if(aboutButton)
            {
                var aboutText = document.documentElement.getAttribute("title");
                aboutButton.setAttribute("label", aboutText);
            }

            document.title = document.documentElement.getAttribute("creditstitle");
            dialogAboutNetizenDeck.selectedIndex = 1;
        }
        else
        {
            var creditsButton = document.documentElement.getButton("extra2");
            if(creditsButton)
            {
                var creditsText = document.documentElement.getAttribute("buttonlabelextra2");
                creditsButton.setAttribute("label", creditsText);                
            }

            document.title = document.documentElement.getAttribute("title");
            dialogAboutNetizenDeck.selectedIndex = 0;
        }
        
        return;
    }
};

