/***** BEGIN License Block *****
 * Version 1.1 MPL
 *
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License").  You may not use this 
 * file except in compliance with the License. You may obtain a 
 * copy of the License at http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed on an 
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express  
 * or implied. See the License for the specific language governing 
 * rights and limitations under the License.
 *
 * The Original Code is Civil Netizen/Civil Servant.
 *
 * The Initial Developer of the Original Code is Civil Engines 
 * Research. Portions created by Civil Engines Research LLC are 
 * Copyright (C) 2001-2005 Civil Engines Research.  All Rights 
 * Reserved.  
 *
 * Portions created by Netscape Copyright (C) 1998 Netscape 
 * Communications Corporation. All Rights Reserved.
 *
 * Portions created by the Mozilla Foundation are Copyright (C) 
 * 2003 Mozilla Foundation. All Rights Reserved.
 *
 * Redistribution of the Original Code or portions of the Original
 * Code or Software under this agreement must retain the above 
 * copyright notice, this redistribution statement and the following 
 * disclaimer.  Neither the name of Civil Engines Research nor the 
 * names of its contributors may be used to endorse or promote any
 * products derived from this software without specific prior 
 * written permission from Civil Engines Research.
 *
 *
 * Contributor(s): 
 *   Paolo de Dios <paolo.dedios@civilengines.com> (original author)
 *
 *
 ***** END License Block *****/


var ParcelConfirmDeleteDialog =
{
    loadDialog : function(eventInfo)
    {
        var dialogStringBundle = document.getElementById("parcelStringBundle");
        if(dialogStringBundle)
        {
            this.loadStringBundle(dialogStringBundle);
        }

        var deleteCount = window.arguments[0];
        if(deleteCount)
        {
            this.loadDialogContent(deleteCount);
        }
        
        return;
    },

    unloadDialog : function(eventInfo)
    {
        return;
    },

    loadStringBundle : function(dialogStringBundle)
    {
        if(!dialogStringBundle)
        {
            return;
        }
        
        this.confirmationString = dialogStringBundle.getString("parcel.dialog.delete.confirm");
        this.singleParcelString = dialogStringBundle.getString("parcel.dialog.delete.single");
        this.multiParcelString  = dialogStringBundle.getString("parcel.dialog.delete.multi");
        
        return;
    },

    loadDialogContent : function(deleteCount)
    {
        var parcelCountString = "";
        if(deleteCount > 1)
        {
            parcelCountString = this.multiParcelString.substitute(deleteCount);
        }
        else if(deleteCount == 1)
        {
            parcelCountString = this.singleParcelString;
        }
        else
        {
            return;
        }
        
        var deleteConfirmationString = this.confirmationString.substitute(parcelCountString);
        if(deleteConfirmationString)
        {
            var confirmationLabel = document.getElementById("parcelConfirmLabel");
            if(confirmationLabel)
            {
                confirmationLabel.setAttribute("value", deleteConfirmationString);
            }
        }
        
        return;
    },
    
    acceptDelete : function(eventInfo)
    {
        var windowOpener = window.opener;
        if(!windowOpener)
        {
            return;
        }
        
        var deleteController = windowOpener.wrappedJSObject.ParcelTrackerController;
        if(deleteController)
        {
            if(window.arguments[1] == true)
            {
                deleteController.trackerDeleteExpired();
            }
            else
            {
                deleteController.trackerDeleteSelection();
            }
            
            deleteController.onCommandUpdate();
        
            return;
        }


        deleteController = windowOpener.wrappedJSObject.ParcelDetailsViewController;
        if(deleteController)
        {
            deleteController.deleteParcelResource();
            deleteController.onCommandUpdate();
        }
        
        return;
    }

};

