/***** BEGIN License Block *****
 * Version 1.1 MPL
 *
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License").  You may not use this 
 * file except in compliance with the License. You may obtain a 
 * copy of the License at http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed on an 
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express  
 * or implied. See the License for the specific language governing 
 * rights and limitations under the License.
 *
 * The Original Code is Civil Netizen/Civil Servant.
 *
 * The Initial Developer of the Original Code is Civil Engines 
 * Research. Portions created by Civil Engines Research LLC are 
 * Copyright (C) 2001-2005 Civil Engines Research.  All Rights 
 * Reserved.  
 *
 * Portions created by Netscape Copyright (C) 1998 Netscape 
 * Communications Corporation. All Rights Reserved.
 *
 * Portions created by the Mozilla Foundation are Copyright (C) 
 * 2003 Mozilla Foundation. All Rights Reserved.
 *
 * Redistribution of the Original Code or portions of the Original
 * Code or Software under this agreement must retain the above 
 * copyright notice, this redistribution statement and the following 
 * disclaimer.  Neither the name of Civil Engines Research nor the 
 * names of its contributors may be used to endorse or promote any
 * products derived from this software without specific prior 
 * written permission from Civil Engines Research.
 *
 *
 * Contributor(s): 
 *   Paolo de Dios <paolo.dedios@civilengines.com> (original author)
 *
 *
 ***** END License Block *****/

var   ParcelPackageAppURL                  = "chrome://netizen/content/parcel/parcelAppSend.xul";
var   ParcelPickupAppURL                   = "chrome://netizen/content/parcel/parcelAppPickup.xul";
var   ParcelTrackStatusURL                 = "chrome://netizen/content/parcel/parcelAppTrack.xul";
var   ParcelApplicationName                = "parcel";


var ParcelMenuCommandController  =
{
    onLoad : function()
    {
        top.controllers.appendController(ParcelMenuCommandController);    
        return;
    },

    
    onUnload : function()
    {
        top.controllers.removeController(ParcelMenuCommandController);
        return;
    },
    

    supportsCommand : function(commandId)
    {
        switch(commandId)
        {
          case "cmd_netizenSwitchToParcel":
          case "cmd_parcelGoPackageNew"   :
          case "cmd_parcelGoPickup"       :
          case "cmd_parcelGoTrackStatus"  :
          {      
              return true;
          }
        }

        return false;
    },


    isCommandEnabled : function(commandId)
    {
        return true;
    },
    

    doCommand : function(commandId)
    {
        switch(commandId)
        {
          case "cmd_parcelGoPackageNew"   :
          {
              NetizenWindowController.switchApplicationModeToTarget(ParcelPackageAppURL);
              break;
          }
          case "cmd_parcelGoPickup"       :
          {
              NetizenWindowController.switchApplicationModeToTarget(ParcelPickupAppURL);
              break;
          }
          case "cmd_parcelGoTrackStatus"  :
          {      
              NetizenWindowController.switchApplicationModeToTarget(ParcelTrackStatusURL);
              break;
          }
          case "cmd_netizenSwitchToParcel":
          {
              NetizenWindowController.switchApplicationToTarget(ParcelPackageAppURL  , 
                                                                ParcelApplicationName);
              break;
          }
        }

        this.onCommandUpdate();
        return;
    },


    onCommandUpdate : function()
    {
        var goPackageIsEnabled = this.isCommandEnabled("cmd_parcelGoPackageNew");
        var goPickupIsEnabled  = this.isCommandEnabled("cmd_parcelGoPickup");
        var goTrackIsEnabled   = this.isCommandEnabled("cmd_parcelGoTrackStatus");
        
        goSetCommandEnabled("cmd_parcelGoPackageNew" , goPackageIsEnabled);
        goSetCommandEnabled("cmd_parcelGoPickup"     , goPickupIsEnabled );
        goSetCommandEnabled("cmd_parcelGoTrackStatus", goTrackIsEnabled  );

        return;
    }
};


ParcelMenuCommandController.onLoad();

