/***** BEGIN License Block *****
 * Version 1.1 MPL
 *
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License").  You may not use this 
 * file except in compliance with the License. You may obtain a 
 * copy of the License at http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed on an 
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express  
 * or implied. See the License for the specific language governing 
 * rights and limitations under the License.
 *
 * The Original Code is the Civil Netizen/Civil Servant.
 *
 * The Initial Developer of the Original Code is Civil Engines 
 * Research. Portions created by Civil Engines Research LLC are 
 * Copyright (C) 2001-2003 Civil Engines Research.  All Rights 
 * Reserved.
 *
 * Redistribution of the Original Code or portions of the Original
 * Code or Software under this agreement must retain the above 
 * copyright notice, this redistribution statement and the following 
 * disclaimer.  Neither the name of Civil Engines Research nor the 
 * names of its contributors may be used to endorse or promote any
 * products derived from this software without specific prior 
 * written permission from Civil Engines Research.
 *
 *
 * Contributor(s): 
 *   Paolo de Dios <paolo.dedios@civilengines.com> (original author)
 *
 *
 ***** END License Block *****/

const TRANSFER_STATUS_RESOLVING      = "urn:network:transfer:status:resolving";
const TRANSFER_STATUS_STARTED        = "urn:network:transfer:status:started";
const TRANSFER_STATUS_TRANSFERRING   = "urn:network:transfer:status:transferring";
const TRANSFER_STATUS_COMPLETE       = "urn:network:transfer:status:complete";
const TRANSFER_STATUS_FAILED         = "urn:network:transfer:status:failed";
const TRANSFER_STATUS_CANCELED       = "urn:network:transfer:status:canceled";
const TRANSFER_STATUS_NOTFOUND       = "urn:network:transfer:status:notfound";

const TRANSFER_STATUS_RESTARTING     = "urn:network:transfer:status:restarting";
const TRANSFER_STATUS_RESTARTED      = "urn:network:transfer:status:restarted";
const TRANSFER_STATUS_INTERRUPTED    = "urn:network:transfer:status:interrupted";

const TRANSFER_EVENT_PAUSE           = "urn:network:transfer:event:pause";
const TRANSFER_EVENT_RESUME          = "urn:network:transfer:event:resume";
const TRANSFER_EVENT_CANCEL          = "urn:network:transfer:event:cancel";
const TRANSFER_EVENT_RETRY           = "urn:network:transfer:event:retry";
const TRANSFER_EVENT_REMOVE          = "urn:network:transfer:event:remove";
const TRANSFER_EVENT_ANIMATED        = "urn:network:transfer:event:animated";
const TRANSFER_EVENT_DETAILS         = "urn:network:transfer:event:details";
const TRANSFER_EVENT_OPEN            = "urn:network:transfer:event:open";


function ceAbstractTransferObserver()
{
    return;
}


ceAbstractTransferObserver.prototype =
{
    loadObservers : function()
    {
        ObserverService.addObserver(this, TRANSFER_STATUS_RESOLVING   , false);
        ObserverService.addObserver(this, TRANSFER_STATUS_STARTED     , false);
        ObserverService.addObserver(this, TRANSFER_STATUS_TRANSFERRING, false);
        ObserverService.addObserver(this, TRANSFER_STATUS_COMPLETE    , false);
        ObserverService.addObserver(this, TRANSFER_STATUS_FAILED      , false);
        ObserverService.addObserver(this, TRANSFER_STATUS_CANCELED    , false);
        ObserverService.addObserver(this, TRANSFER_STATUS_NOTFOUND    , false);
        
        ObserverService.addObserver(this, TRANSFER_STATUS_RESTARTING  , false);
        ObserverService.addObserver(this, TRANSFER_STATUS_RESTARTED   , false);
        ObserverService.addObserver(this, TRANSFER_STATUS_INTERRUPTED , false);

        return;
    },

    unloadObservers : function()
    {
        ObserverService.removeObserver(this, TRANSFER_STATUS_RESOLVING   );
        ObserverService.removeObserver(this, TRANSFER_STATUS_STARTED     );
        ObserverService.removeObserver(this, TRANSFER_STATUS_TRANSFERRING);
        ObserverService.removeObserver(this, TRANSFER_STATUS_COMPLETE    );
        ObserverService.removeObserver(this, TRANSFER_STATUS_FAILED      );
        ObserverService.removeObserver(this, TRANSFER_STATUS_CANCELED    );
        ObserverService.removeObserver(this, TRANSFER_STATUS_NOTFOUND    );
        
        ObserverService.removeObserver(this, TRANSFER_STATUS_RESTARTING  );
        ObserverService.removeObserver(this, TRANSFER_STATUS_RESTARTED   );
        ObserverService.removeObserver(this, TRANSFER_STATUS_INTERRUPTED );

        return;
    },

    QueryInterface : function(iid)
    {
        if(iid.equals(Interfaces.nsIObserver) ||
           iid.equals(Interfaces.nsISupports)  )
        {
            return this;
        }
        
        throw Results.NS_NOINTERFACE;
    },

    observe : function(subject, topic, state)
    {
        return;
    } 
};


